## ats2-lang 0.3.11

=== src/Makefile ===
#
#
# This Makefile is automatically generated
# from executing the following command-line:
#
# make -f Makefile.gen
#
#

######
#
CC=gcc
CCOMP=$(CC)
#
export ATSCCOMP=$(CC)
#
######

ATSCC=$(ATSHOME)/bin/atscc
ATSOPT=$(ATSHOME)/bin/atsopt

######

CFLAGS=-g
#CFLAGS=-g -O
#CFLAGS=-g -O2

######
#
GCFLAG=
#
# GCFLAG=-D_ATS_NGC
# GCFLAG=-D_ATS_GCBDW
# GCFLAG=-D_ATS_GCATS
#
######
#
# Bootstrapping:
#
# [gmpknd] for CBOOT
# [intknd] for CBOOTmin
#
C3NSTRINTKND=gmpknd
#C3NSTRINTKND=intknd
#
######
#
DATSCC=-DATS \
C3NSTRINTKND=$(C3NSTRINTKND)
#
######

LIBATS=-lats

######
#
# HX: no [gmp] 
ifeq ($(C3NSTRINTKND),intknd)
LIBGMP=
endif
#
# HX: [gmp] needed
ifeq ($(C3NSTRINTKND),gmpknd)
LIBGMP=-lgmp
endif
#
######

SOURCES := \
  pats_params.hats \
  pats_error.sats \
  pats_error.dats \
  pats_intinf.sats \
  pats_intinf.dats \
  pats_intinf_int.hats \
  pats_intinf_gmp.hats \
  pats_counter.sats \
  pats_counter.dats \
  pats_utils.sats \
  pats_utils.dats \
  pats_global.sats \
  pats_global.dats \
  pats_basics.sats \
  pats_basics.dats \
  pats_basics.hats \
  pats_comarg.sats \
  pats_comarg.dats \
  pats_stamp.sats \
  pats_stamp.dats \
  pats_symbol.sats \
  pats_symbol.dats \
  pats_filename.sats \
  pats_filename.dats \
  pats_filename_reloc.dats \
  pats_location.sats \
  pats_location.dats \
  pats_location.cats \
  pats_jsonize.sats \
  pats_jsonize.dats \
  pats_errmsg.sats \
  pats_errmsg.dats \
  pats_reader.sats \
  pats_reader.dats \
  pats_reader.cats \
  pats_lexbuf.sats \
  pats_lexbuf.dats \
  pats_lexbuf.cats \
  pats_lexing.sats \
  pats_lexing.dats \
  pats_lexing.cats \
  pats_lexing_print.dats \
  pats_lexing_error.dats \
  pats_lexing_token.dats \
  pats_label.sats \
  pats_label.dats \
  pats_effect.sats \
  pats_effect.dats \
  pats_fixity.sats \
  pats_fixity_prec.dats \
  pats_fixity_fxty.dats \
  pats_syntax.sats \
  pats_syntax.dats \
  pats_syntax_print.dats \
  pats_depgen.sats \
  pats_depgen.dats \
  pats_taggen.sats \
  pats_taggen.dats \
  pats_tokbuf.sats \
  pats_tokbuf.dats \
  pats_tokbuf.cats \
  pats_parsing.sats \
  pats_parsing.dats \
  pats_parsing_error.dats \
  pats_parsing_util.dats \
  pats_parsing_kwds.dats \
  pats_parsing_base.dats \
  pats_parsing_e0xp.dats \
  pats_parsing_sort.dats \
  pats_parsing_staexp.dats \
  pats_parsing_p0at.dats \
  pats_parsing_dynexp.dats \
  pats_parsing_decl.dats \
  pats_parsing_toplevel.dats \
  pats_symmap.sats \
  pats_symmap.dats \
  pats_symmap_avltree.hats \
  pats_symmap_htlinprb.hats \
  pats_symenv.sats \
  pats_symenv.dats \
  pats_staexp1.sats \
  pats_staexp1.dats \
  pats_staexp1_print.dats \
  pats_dynexp1.sats \
  pats_dynexp1.dats \
  pats_dynexp1_print.dats \
  pats_trans1.sats \
  pats_trans1_env.sats \
  pats_trans1_env.dats \
  pats_e1xpval.sats \
  pats_e1xpval.dats \
  pats_e1xpval_error.dats \
  pats_trans1_error.dats \
  pats_trans1_e0xp.dats \
  pats_trans1_effect.dats \
  pats_trans1_sort.dats \
  pats_trans1_staexp.dats \
  pats_trans1_p0at.dats \
  pats_trans1_syndef.dats \
  pats_trans1_dynexp.dats \
  pats_trans1_decl.dats \
  pats_staexp2.sats \
  pats_staexp2.dats \
  pats_stacst2.sats \
  pats_stacst2.dats \
  pats_staexp2_print.dats \
  pats_staexp2_pprint.dats \
  pats_staexp2_sort.dats \
  pats_staexp2_scst.dats \
  pats_staexp2_svar.dats \
  pats_staexp2_svvar.dats \
  pats_staexp2_hole.dats \
  pats_staexp2_ctxt.dats \
  pats_staexp2_dcon.dats \
  pats_staexp2_skexp.dats \
  pats_staexp2_szexp.dats \
  pats_staexp2_util.sats \
  pats_staexp2_util1.dats \
  pats_staexp2_util2.dats \
  pats_staexp2_util3.dats \
  pats_staexp2_error.sats \
  pats_staexp2_error.dats \
  pats_staexp2_solve.sats \
  pats_staexp2_solve.dats \
  pats_patcst2.sats \
  pats_patcst2.dats \
  pats_dynexp2.sats \
  pats_dynexp2.dats \
  pats_dyncst2.sats \
  pats_dyncst2.dats \
  pats_dynexp2_print.dats \
  pats_dynexp2_dcst.dats \
  pats_dynexp2_dvar.dats \
  pats_dynexp2_dmac.dats \
  pats_dynexp2_util.dats \
  pats_staexp2_appenv.hats \
  pats_dynexp2_appenv.hats \
  pats_dynexp2_mapgen.dats \
  pats_trans2.sats \
  pats_namespace.sats \
  pats_namespace.dats \
  pats_trans2_env.sats \
  pats_trans2_env.dats \
  pats_trans2_error.dats \
  pats_trans2_sort.dats \
  pats_trans2_staexp.dats \
  pats_trans2_p1at.dats \
  pats_trans2_dynexp.dats \
  pats_trans2_impdec.dats \
  pats_trans2_decl.dats \
  pats_codegen2.sats \
  pats_codegen2.dats \
  pats_codegen2_util.dats \
  pats_codegen2_absrec.dats \
  pats_codegen2_datype.dats \
  pats_codegen2_fprint.dats \
  pats_jsonize_synent2.sats \
  pats_jsonize_synent2.dats \
  pats_dynexp3.sats \
  pats_dynexp3.dats \
  pats_dynexp3_print.dats \
  pats_trans3.sats \
  pats_trans3_error.dats \
  pats_trans3_util.dats \
  pats_trans3_env.sats \
  pats_trans3_env.dats \
  pats_trans3_env_print.dats \
  pats_trans3_env_scst.dats \
  pats_trans3_env_svar.dats \
  pats_trans3_env_termet.dats \
  pats_trans3_env_effect.dats \
  pats_trans3_env_dvar.dats \
  pats_trans3_env_lamlp.dats \
  pats_trans3_env_pfman.dats \
  pats_trans3_env_lstate.dats \
  pats_dmacro2.sats \
  pats_dmacro2.dats \
  pats_dmacro2_print.dats \
  pats_dmacro2_eval0.dats \
  pats_dmacro2_eval1.dats \
  pats_trans3_p2at.dats \
  pats_trans3_patcon.dats \
  pats_trans3_syncst.dats \
  pats_trans3_dynexp_up.dats \
  pats_trans3_dynexp_dn.dats \
  pats_trans3_appsym.dats \
  pats_trans3_caseof.dats \
  pats_trans3_selab.dats \
  pats_trans3_ptrof.dats \
  pats_trans3_viewat.dats \
  pats_trans3_deref.dats \
  pats_trans3_assgn.dats \
  pats_trans3_xchng.dats \
  pats_trans3_lvalres.dats \
  pats_trans3_fldfrat.dats \
  pats_trans3_looping.dats \
  pats_trans3_decl.dats \
  pats_lintprgm.sats \
  pats_lintprgm.dats \
  pats_lintprgm_print.dats \
  pats_lintprgm_myint.cats \
  pats_lintprgm_myint.dats \
  pats_lintprgm_solve.dats \
  pats_constraint3.sats \
  pats_constraint3.dats \
  pats_constraint3_print.dats \
  pats_constraint3_appenv.hats \
  pats_constraint3_mapgen.dats \
  pats_constraint3_jsonize.dats \
  pats_constraint3_init.dats \
  pats_constraint3_simplify.dats \
  pats_constraint3_icnstr.dats \
  pats_constraint3_solve.dats \
  pats_histaexp.sats \
  pats_histaexp.dats \
  pats_histaexp_print.dats \
  pats_histaexp_funlab.dats \
  pats_hidynexp.sats \
  pats_hidynexp.dats \
  pats_hidynexp_print.dats \
  pats_hidynexp_util.dats \
  pats_typerase.sats \
  pats_typerase_error.dats \
  pats_typerase_staexp.dats \
  pats_typerase_dynexp.dats \
  pats_typerase_decl.dats \
  pats_ccomp.sats \
  pats_ccomp.dats \
  pats_ccomp_print.dats \
  pats_ccomp_hitype.dats \
  pats_ccomp_tmplab.dats \
  pats_ccomp_tmpvar.dats \
  pats_ccomp_d2env.dats \
  pats_ccomp_funlab.dats \
  pats_ccomp_funent.dats \
  pats_ccomp_util.dats \
  pats_ccomp_ccompenv.dats \
  pats_ccomp_instrseq.dats \
  pats_ccomp_hipat.dats \
  pats_ccomp_dynexp.dats \
  pats_ccomp_caseof.dats \
  pats_ccomp_claulst.dats \
  pats_ccomp_lazyeval.dats \
  pats_ccomp_trywith.dats \
  pats_ccomp_looping.dats \
  pats_ccomp_decl.dats \
  pats_ccomp_subst.dats \
  pats_ccomp_environ.dats \
  pats_ccomp_template.dats \
  pats_ccomp_emit.dats \
  pats_ccomp_emit2.dats \
  pats_ccomp_emit3.dats \
  pats_ccomp_main.dats \


SOURCESsta := $(filter %.sats, $(SOURCES))
SOURCESdyn := $(filter %.dats, $(SOURCES))

######

TARGETS := \
  pats_error_sats.c \
  pats_error_dats.c \
  pats_intinf_sats.c \
  pats_intinf_dats.c \
  pats_counter_sats.c \
  pats_counter_dats.c \
  pats_utils_sats.c \
  pats_utils_dats.c \
  pats_global_sats.c \
  pats_global_dats.c \
  pats_basics_sats.c \
  pats_basics_dats.c \
  pats_comarg_sats.c \
  pats_comarg_dats.c \
  pats_stamp_sats.c \
  pats_stamp_dats.c \
  pats_symbol_sats.c \
  pats_symbol_dats.c \
  pats_filename_sats.c \
  pats_filename_dats.c \
  pats_filename_reloc_dats.c \
  pats_location_sats.c \
  pats_location_dats.c \
  pats_jsonize_sats.c \
  pats_jsonize_dats.c \
  pats_errmsg_sats.c \
  pats_errmsg_dats.c \
  pats_reader_sats.c \
  pats_reader_dats.c \
  pats_lexbuf_sats.c \
  pats_lexbuf_dats.c \
  pats_lexing_sats.c \
  pats_lexing_dats.c \
  pats_lexing_print_dats.c \
  pats_lexing_error_dats.c \
  pats_lexing_token_dats.c \
  pats_label_sats.c \
  pats_label_dats.c \
  pats_effect_sats.c \
  pats_effect_dats.c \
  pats_fixity_sats.c \
  pats_fixity_prec_dats.c \
  pats_fixity_fxty_dats.c \
  pats_syntax_sats.c \
  pats_syntax_dats.c \
  pats_syntax_print_dats.c \
  pats_depgen_sats.c \
  pats_depgen_dats.c \
  pats_taggen_sats.c \
  pats_taggen_dats.c \
  pats_tokbuf_sats.c \
  pats_tokbuf_dats.c \
  pats_parsing_sats.c \
  pats_parsing_dats.c \
  pats_parsing_error_dats.c \
  pats_parsing_util_dats.c \
  pats_parsing_kwds_dats.c \
  pats_parsing_base_dats.c \
  pats_parsing_e0xp_dats.c \
  pats_parsing_sort_dats.c \
  pats_parsing_staexp_dats.c \
  pats_parsing_p0at_dats.c \
  pats_parsing_dynexp_dats.c \
  pats_parsing_decl_dats.c \
  pats_parsing_toplevel_dats.c \
  pats_symmap_sats.c \
  pats_symmap_dats.c \
  pats_symenv_sats.c \
  pats_symenv_dats.c \
  pats_staexp1_sats.c \
  pats_staexp1_dats.c \
  pats_staexp1_print_dats.c \
  pats_dynexp1_sats.c \
  pats_dynexp1_dats.c \
  pats_dynexp1_print_dats.c \
  pats_trans1_sats.c \
  pats_trans1_env_sats.c \
  pats_trans1_env_dats.c \
  pats_e1xpval_sats.c \
  pats_e1xpval_dats.c \
  pats_e1xpval_error_dats.c \
  pats_trans1_error_dats.c \
  pats_trans1_e0xp_dats.c \
  pats_trans1_effect_dats.c \
  pats_trans1_sort_dats.c \
  pats_trans1_staexp_dats.c \
  pats_trans1_p0at_dats.c \
  pats_trans1_syndef_dats.c \
  pats_trans1_dynexp_dats.c \
  pats_trans1_decl_dats.c \
  pats_staexp2_sats.c \
  pats_staexp2_dats.c \
  pats_stacst2_sats.c \
  pats_stacst2_dats.c \
  pats_staexp2_print_dats.c \
  pats_staexp2_pprint_dats.c \
  pats_staexp2_sort_dats.c \
  pats_staexp2_scst_dats.c \
  pats_staexp2_svar_dats.c \
  pats_staexp2_svvar_dats.c \
  pats_staexp2_hole_dats.c \
  pats_staexp2_ctxt_dats.c \
  pats_staexp2_dcon_dats.c \
  pats_staexp2_skexp_dats.c \
  pats_staexp2_szexp_dats.c \
  pats_staexp2_util_sats.c \
  pats_staexp2_util1_dats.c \
  pats_staexp2_util2_dats.c \
  pats_staexp2_util3_dats.c \
  pats_staexp2_error_sats.c \
  pats_staexp2_error_dats.c \
  pats_staexp2_solve_sats.c \
  pats_staexp2_solve_dats.c \
  pats_patcst2_sats.c \
  pats_patcst2_dats.c \
  pats_dynexp2_sats.c \
  pats_dynexp2_dats.c \
  pats_dyncst2_sats.c \
  pats_dyncst2_dats.c \
  pats_dynexp2_print_dats.c \
  pats_dynexp2_dcst_dats.c \
  pats_dynexp2_dvar_dats.c \
  pats_dynexp2_dmac_dats.c \
  pats_dynexp2_util_dats.c \
  pats_dynexp2_mapgen_dats.c \
  pats_trans2_sats.c \
  pats_namespace_sats.c \
  pats_namespace_dats.c \
  pats_trans2_env_sats.c \
  pats_trans2_env_dats.c \
  pats_trans2_error_dats.c \
  pats_trans2_sort_dats.c \
  pats_trans2_staexp_dats.c \
  pats_trans2_p1at_dats.c \
  pats_trans2_dynexp_dats.c \
  pats_trans2_impdec_dats.c \
  pats_trans2_decl_dats.c \
  pats_codegen2_sats.c \
  pats_codegen2_dats.c \
  pats_codegen2_util_dats.c \
  pats_codegen2_absrec_dats.c \
  pats_codegen2_datype_dats.c \
  pats_codegen2_fprint_dats.c \
  pats_jsonize_synent2_sats.c \
  pats_jsonize_synent2_dats.c \
  pats_dynexp3_sats.c \
  pats_dynexp3_dats.c \
  pats_dynexp3_print_dats.c \
  pats_trans3_sats.c \
  pats_trans3_error_dats.c \
  pats_trans3_util_dats.c \
  pats_trans3_env_sats.c \
  pats_trans3_env_dats.c \
  pats_trans3_env_print_dats.c \
  pats_trans3_env_scst_dats.c \
  pats_trans3_env_svar_dats.c \
  pats_trans3_env_termet_dats.c \
  pats_trans3_env_effect_dats.c \
  pats_trans3_env_dvar_dats.c \
  pats_trans3_env_lamlp_dats.c \
  pats_trans3_env_pfman_dats.c \
  pats_trans3_env_lstate_dats.c \
  pats_dmacro2_sats.c \
  pats_dmacro2_dats.c \
  pats_dmacro2_print_dats.c \
  pats_dmacro2_eval0_dats.c \
  pats_dmacro2_eval1_dats.c \
  pats_trans3_p2at_dats.c \
  pats_trans3_patcon_dats.c \
  pats_trans3_syncst_dats.c \
  pats_trans3_dynexp_up_dats.c \
  pats_trans3_dynexp_dn_dats.c \
  pats_trans3_appsym_dats.c \

=== src/CBOOT/Makefile ===
######
#
# The main Makefile
# for C-bootstrapping ATS2
#
######
#
CC=gcc
GCC=gcc
CCOMP=$(CC)
#
# GCFLAG=-D_ATS_NGC
# GCFLAG=-D_ATS_GCATS
# GCFLAG=-D_ATS_GCBDW
#
# CFLAGS=
# LDFLAGS=
#
######

CFLAGS += -I. -I./ccomp/runtime

######
#
# This is fixed:
#
C3NSTRINTKND=gmpknd
#
# [gmpknd] for CBOOT
# [intknd] for CBOOTmin
#
######
#
LIBGMP=
#
ifeq ($(C3NSTRINTKND),intknd)
LIBGMP :=
endif
ifeq ($(C3NSTRINTKND),gmpknd)
LIBGMP := -lgmp
endif
#
######
#
LIBGC=
gcats_o=
#
ifeq ($(GCFLAG),-D_ATS_GCBDW)
  LIBGC := -lgc
endif
ifeq ($(GCFLAG),-D_ATS_GCATS)
  gcats_o := gcats.o
endif
#
######

all:: patsopt

######

SOURCES := \
  pats_params.hats \
  pats_error.sats \
  pats_error.dats \
  pats_intinf.sats \
  pats_intinf.dats \
  pats_counter.sats \
  pats_counter.dats \
  pats_utils.sats \
  pats_utils.dats \
  pats_global.sats \
  pats_global.dats \
  pats_basics.sats \
  pats_basics.dats \
  pats_basics.hats \
  pats_stamp.sats \
  pats_stamp.dats \
  pats_symbol.sats \
  pats_symbol.dats \
  pats_filename.sats \
  pats_filename.dats \
  pats_location.sats \
  pats_location.dats \
  pats_location.cats \
  pats_jsonize.sats \
  pats_jsonize.dats \
  pats_errmsg.sats \
  pats_errmsg.dats \
  pats_reader.sats \
  pats_reader.dats \
  pats_reader.cats \
  pats_lexbuf.sats \
  pats_lexbuf.dats \
  pats_lexbuf.cats \
  pats_lexing.sats \
  pats_lexing.dats \
  pats_lexing.cats \
  pats_lexing_print.dats \
  pats_lexing_error.dats \
  pats_lexing_token.dats \
  pats_label.sats \
  pats_label.dats \
  pats_effect.sats \
  pats_effect.dats \
  pats_fixity.sats \
  pats_fixity_prec.dats \
  pats_fixity_fxty.dats \
  pats_syntax.sats \
  pats_syntax.dats \
  pats_syntax_print.dats \
  pats_depgen.sats \
  pats_depgen.dats \
  pats_taggen.sats \
  pats_taggen.dats \
  pats_tokbuf.sats \
  pats_tokbuf.dats \
  pats_tokbuf.cats \
  pats_parsing.sats \
  pats_parsing.dats \
  pats_parsing_error.dats \
  pats_parsing_util.dats \
  pats_parsing_kwds.dats \
  pats_parsing_base.dats \
  pats_parsing_e0xp.dats \
  pats_parsing_sort.dats \
  pats_parsing_staexp.dats \
  pats_parsing_p0at.dats \
  pats_parsing_dynexp.dats \
  pats_parsing_decl.dats \
  pats_parsing_toplevel.dats \
  pats_symmap.sats \
  pats_symmap.dats \
  pats_symmap_avltree.hats \
  pats_symmap_htlinprb.hats \
  pats_symenv.sats \
  pats_symenv.dats \
  pats_staexp1.sats \
  pats_staexp1.dats \
  pats_staexp1_print.dats \
  pats_dynexp1.sats \
  pats_dynexp1.dats \
  pats_dynexp1_print.dats \
  pats_trans1.sats \
  pats_trans1_env.sats \
  pats_trans1_env.dats \
  pats_e1xpval.sats \
  pats_e1xpval.dats \
  pats_e1xpval_error.dats \
  pats_filename_reloc.dats \
  pats_trans1_error.dats \
  pats_trans1_e0xp.dats \
  pats_trans1_effect.dats \
  pats_trans1_sort.dats \
  pats_trans1_staexp.dats \
  pats_trans1_p0at.dats \
  pats_trans1_syndef.dats \
  pats_trans1_dynexp.dats \
  pats_trans1_decl.dats \
  pats_staexp2.sats \
  pats_staexp2.dats \
  pats_stacst2.sats \
  pats_stacst2.dats \
  pats_staexp2_print.dats \
  pats_staexp2_pprint.dats \
  pats_staexp2_sort.dats \
  pats_staexp2_scst.dats \
  pats_staexp2_svar.dats \
  pats_staexp2_svvar.dats \
  pats_staexp2_hole.dats \
  pats_staexp2_ctxt.dats \
  pats_staexp2_dcon.dats \
  pats_staexp2_skexp.dats \
  pats_staexp2_szexp.dats \
  pats_staexp2_util.sats \
  pats_staexp2_util1.dats \
  pats_staexp2_util2.dats \
  pats_staexp2_util3.dats \
  pats_staexp2_error.sats \
  pats_staexp2_error.dats \
  pats_staexp2_solve.sats \
  pats_staexp2_solve.dats \
  pats_patcst2.sats \
  pats_patcst2.dats \
  pats_dynexp2.sats \
  pats_dynexp2.dats \
  pats_dyncst2.sats \
  pats_dyncst2.dats \
  pats_dynexp2_print.dats \
  pats_dynexp2_dcst.dats \
  pats_dynexp2_dvar.dats \
  pats_dynexp2_dmac.dats \
  pats_dynexp2_util.dats \
  pats_dynexp2_mapgen.dats \
  pats_codegen2.sats \
  pats_codegen2.dats \
  pats_codegen2_util.dats \
  pats_codegen2_absrec.dats \
  pats_codegen2_datype.dats \
  pats_codegen2_fprint.dats \
  pats_jsonize_synent2.sats \
  pats_jsonize_synent2.dats \
  pats_trans2.sats \
  pats_namespace.sats \
  pats_namespace.dats \
  pats_trans2_env.sats \
  pats_trans2_env.dats \
  pats_trans2_error.dats \
  pats_trans2_sort.dats \
  pats_trans2_staexp.dats \
  pats_trans2_p1at.dats \
  pats_trans2_dynexp.dats \
  pats_trans2_impdec.dats \
  pats_trans2_decl.dats \
  pats_dynexp3.sats \
  pats_dynexp3.dats \
  pats_dynexp3_print.dats \
  pats_trans3.sats \
  pats_trans3_error.dats \
  pats_trans3_util.dats \
  pats_trans3_env.sats \
  pats_trans3_env.dats \
  pats_trans3_env_print.dats \
  pats_trans3_env_scst.dats \
  pats_trans3_env_svar.dats \
  pats_trans3_env_termet.dats \
  pats_trans3_env_effect.dats \
  pats_trans3_env_dvar.dats \
  pats_trans3_env_lamlp.dats \
  pats_trans3_env_pfman.dats \
  pats_trans3_env_lstate.dats \
  pats_dmacro2.sats \
  pats_dmacro2.dats \
  pats_dmacro2_print.dats \
  pats_dmacro2_eval0.dats \
  pats_dmacro2_eval1.dats \
  pats_trans3_p2at.dats \
  pats_trans3_patcon.dats \
  pats_trans3_syncst.dats \
  pats_trans3_dynexp_up.dats \
  pats_trans3_dynexp_dn.dats \
  pats_trans3_appsym.dats \
  pats_trans3_caseof.dats \
  pats_trans3_selab.dats \
  pats_trans3_ptrof.dats \
  pats_trans3_viewat.dats \
  pats_trans3_deref.dats \
  pats_trans3_assgn.dats \
  pats_trans3_xchng.dats \
  pats_trans3_lvalres.dats \
  pats_trans3_fldfrat.dats \
  pats_trans3_looping.dats \
  pats_trans3_decl.dats \
  pats_lintprgm.sats \
  pats_lintprgm.dats \
  pats_lintprgm_print.dats \
  pats_lintprgm_myint.cats \
  pats_lintprgm_myint.dats \
  pats_lintprgm_solve.dats \
  pats_constraint3.sats \
  pats_constraint3.dats \
  pats_constraint3_print.dats \
  pats_constraint3_mapgen.dats \
  pats_constraint3_jsonize.dats \
  pats_constraint3_init.dats \
  pats_constraint3_simplify.dats \
  pats_constraint3_icnstr.dats \
  pats_constraint3_solve.dats \
  pats_histaexp.sats \
  pats_histaexp.dats \
  pats_histaexp_print.dats \
  pats_histaexp_funlab.dats \
  pats_hidynexp.sats \
  pats_hidynexp.dats \
  pats_hidynexp_print.dats \
  pats_hidynexp_util.dats \
  pats_typerase.sats \
  pats_typerase_error.dats \
  pats_typerase_staexp.dats \
  pats_typerase_dynexp.dats \
  pats_typerase_decl.dats \
  pats_ccomp.sats \
  pats_ccomp.dats \
  pats_ccomp_print.dats \
  pats_ccomp_hitype.dats \
  pats_ccomp_tmplab.dats \
  pats_ccomp_tmpvar.dats \
  pats_ccomp_d2env.dats \
  pats_ccomp_funlab.dats \
  pats_ccomp_funent.dats \
  pats_ccomp_util.dats \
  pats_ccomp_ccompenv.dats \
  pats_ccomp_instrseq.dats \
  pats_ccomp_hipat.dats \
  pats_ccomp_dynexp.dats \
  pats_ccomp_caseof.dats \
  pats_ccomp_claulst.dats \
  pats_ccomp_lazyeval.dats \
  pats_ccomp_trywith.dats \
  pats_ccomp_looping.dats \
  pats_ccomp_decl.dats \
  pats_ccomp_subst.dats \
  pats_ccomp_environ.dats \
  pats_ccomp_template.dats \
  pats_ccomp_emit.dats \
  pats_ccomp_emit2.dats \
  pats_ccomp_emit3.dats \
  pats_ccomp_main.dats \
  pats_comarg.sats \
  pats_comarg.dats \

######

SOURCESsta := $(filter %.sats, $(SOURCES))
SOURCESdyn := $(filter %.dats, $(SOURCES))

######

OBJECTSsta := $(SOURCESsta)
OBJECTSsta := $(patsubst %.sats, %_sats.o, $(OBJECTSsta))
OBJECTSdyn := $(SOURCESdyn)
OBJECTSdyn := $(patsubst %.dats, %_dats.o, $(OBJECTSdyn))

######

OBJECTSstadyn := $(OBJECTSsta) $(OBJECTSdyn)

######
#
patsopt: \
pats_main_dats.o \
$(OBJECTSstadyn) \
prelude_libats.o \
libc_libats.o libats_libats.o ; \
$(CCOMP) -O2 -I. $(GCFLAG) -o $@ \
  ccomp/runtime/ats_prelude.c $^ $(gcats_o) $(LDFLAGS) $(LIBGMP) $(LIBGC)
#
######
#
AR=ar
MV=mv
#
libatsopt: \
pats_main_none_dats.o \
$(OBJECTSstadyn) \
prelude_libats.o \
libc_libats.o libats_libats.o ; \
$(AR) -r libatsopt.a $^ $(gcats_o)
#
######
#
%_sats.o: %_sats.c ; $(CCOMP) -O2 $(CFLAGS) -c -o $@ $<
%_dats.o: %_dats.c ; $(CCOMP) -O2 $(CFLAGS) -c -o $@ $<
#
######

PRELUDE_OBJECTS := \
  prelude_basics_sta_sats.o \
  prelude_basics_dyn_sats.o \
  prelude_ats_main_prelude_dats.o \
  prelude_DATS_basics_dats.o \
  prelude_DATS_bool_dats.o \
  prelude_DATS_char_dats.o \
  prelude_DATS_float_dats.o \
  prelude_DATS_integer_dats.o \
  prelude_DATS_sizetype_dats.o \
  prelude_DATS_pointer_dats.o \
  prelude_DATS_reference_dats.o \
  prelude_DATS_string_dats.o \
  prelude_DATS_lazy_dats.o \
  prelude_DATS_lazy_vt_dats.o \
  prelude_DATS_printf_dats.o \
  prelude_DATS_filebas_dats.o \
  prelude_DATS_list_dats.o \
  prelude_DATS_list_vt_dats.o \
  prelude_DATS_list0_dats.o \
  prelude_DATS_option_dats.o \
  prelude_DATS_option_vt_dats.o \
  prelude_DATS_option0_dats.o \
  prelude_DATS_array_dats.o \
  prelude_DATS_array0_dats.o \
  prelude_DATS_matrix_dats.o \
  prelude_DATS_matrix0_dats.o \
  prelude_DATS_ptrarr_dats.o \
  prelude_DATS_unsafe_dats.o \

######
#
prelude_%.o: \
prelude/%.c ; $(CCOMP) $(CFLAGS) -c -o $@ $<
#
prelude_libats.o: $(PRELUDE_OBJECTS) ; ld -r -o $@ $^
#
######

LIBC_OBJECTS := \
  libc_SATS_errno_sats.o \
  libc_SATS_fcntl_sats.o \
  libc_DATS_fcntl_dats.o \
  libc_SATS_stdarg_sats.o \
  libc_SATS_stdio_sats.o \
  libc_SATS_stdlib_sats.o \
  libc_SATS_string_sats.o \
  libc_SATS_time_sats.o \
  libc_SATS_unistd_sats.o \
  libc_DATS_unistd_dats.o \
  libc_sys_SATS_stat_sats.o \
  libc_sys_SATS_wait_sats.o \
  libc_sys_SATS_types_sats.o \

ifeq ($(C3NSTRINTKND),gmpknd)
LIBC_OBJECTS += \
  libc_SATS_gmp_sats.o libc_DATS_gmp_dats.o
endif

######
#
libc_%.o: \
libc/%.c ; $(CCOMP) $(CFLAGS) -c -o $@ $<
#
libc_libats.o: $(LIBC_OBJECTS) ; ld -r -o $@ $^
#
######

LIBATS_OBJECTS := \
  libats_SATS_funmap_avltree_sats.o \
  libats_DATS_funmap_avltree_dats.o \
  libats_SATS_funset_avltree_sats.o \
  libats_DATS_funset_avltree_dats.o \
  libats_SATS_funset_listord_sats.o \
  libats_DATS_funset_listord_dats.o \
  libats_SATS_funmset_listord_sats.o \
  libats_DATS_funmset_listord_dats.o \
  libats_SATS_hashtable_chain_sats.o \
  libats_DATS_hashtable_chain_dats.o \
  libats_SATS_hashtable_linprb_sats.o \
  libats_DATS_hashtable_linprb_dats.o \
  libats_SATS_linqueue_arr_sats.o \
  libats_DATS_linqueue_arr_dats.o \
  libats_SATS_linqueue_lst_sats.o \
  libats_DATS_linqueue_lst_dats.o \
  libats_ngc_SATS_deque_arr_sats.o \
  libats_ngc_DATS_deque_arr_dats.o \

######
#
libats_%.o: \
libats/%.c ; $(CCOMP) $(CFLAGS) -c -o $@ $<
#
libats_libats.o: $(LIBATS_OBJECTS) ; ld -r -o $@ $^
#
######
#
gcats.o: \
  gcats1_hats gcats1_all_cats.o ; ld -r -o $@ gcats1_all_cats.o
#
gcats1_hats: ; \
  $(GCC) -E -P -o gcats1.hats -x c ./ccomp/runtime/GCATS/gcats1_master.hats
#
gcats1_all_cats.o: ; \
  $(CCOMP) -O2 -I. -I./ccomp/runtime -c -o $@ -x c ./ccomp/runtime/gcats1_all.cats
#
######

CPF=cp -f
RMF=rm -f

######
#
clean:: ; $(RMF) *~
clean:: ; $(RMF) *_sats.o
clean:: ; $(RMF) *_dats.o
#
clean:: ; $(RMF) gcats1.hats
clean:: ; $(RMF) gcats1_all_cats.o
#
clean:: ; $(RMF) gcats.o
clean:: ; $(RMF) patsopt
clean:: ; $(RMF) prelude_libats.o
clean:: ; $(RMF) libc_libats.o
clean:: ; $(RMF) libats_libats.o
#
######

cleanall:: clean

######

###### end of [Makefile] ######

=== doc/EXAMPLE/MISC/Makefile ===
#
#
# This Makefile is automatically generated
# from executing the following command-line:
#
# make -f Makefile.gen
#
#

######

CCOPT=gcc -std=c99

######

ifeq ("$(PATSHOME)","")
  PATSHOMEQ="$(ATSHOME)"
else
  PATSHOMEQ="$(PATSHOME)"
endif

######

PATSOPT=$(PATSHOMEQ)/bin/patsopt
PATSLIB=$(PATSHOMEQ)/ccomp/atslib/lib

######

all::

######

LNS=ln -s
RMF=rm -f

######
#
all:: arith_overflow
arith_overflow: arith_overflow.exe
arith_overflow.exe: arith_overflow_dats.c ;   $(CCOPT) -D_GNU_SOURCE -O2 -I$(PATSHOMEQ) -I$(PATSHOMEQ)/ccomp/runtime -o $@ $<
arith_overflow_dats.c: arith_overflow.dats ;   $(PATSOPT) -IATS$(PATSHOMEQ)/contrib --output arith_overflow_dats.c --dynamic arith_overflow.dats
clean:: ; $(RMF) arith_overflow_dats.o
clean:: ; $(RMF) arith_overflow_dats.c
cleanall:: ; $(RMF) arith_overflow arith_overflow.exe

all:: coinflip
coinflip: coinflip.exe
coinflip.exe: coinflip_dats.c ;   $(CCOPT) -D_GNU_SOURCE -O2 -I$(PATSHOMEQ) -I$(PATSHOMEQ)/ccomp/runtime -o $@ $<
coinflip_dats.c: coinflip.dats ;   $(PATSOPT) -IATS$(PATSHOMEQ)/contrib --output coinflip_dats.c --dynamic coinflip.dats
clean:: ; $(RMF) coinflip_dats.o
clean:: ; $(RMF) coinflip_dats.c
cleanall:: ; $(RMF) coinflip coinflip.exe

all:: ferryman
ferryman: ferryman.exe
ferryman.exe: ferryman_dats.c ;   $(CCOPT) -D_GNU_SOURCE -O2 -I$(PATSHOMEQ) -I$(PATSHOMEQ)/ccomp/runtime -o $@ $<
ferryman_dats.c: ferryman.dats ;   $(PATSOPT) -IATS$(PATSHOMEQ)/contrib --output ferryman_dats.c --dynamic ferryman.dats
clean:: ; $(RMF) ferryman_dats.o
clean:: ; $(RMF) ferryman_dats.c
cleanall:: ; $(RMF) ferryman ferryman.exe

all:: fibver_loop
fibver_loop: fibver_loop.exe
fibver_loop.exe: fibver_loop_dats.c ;   $(CCOPT) -D_GNU_SOURCE -O2 -I$(PATSHOMEQ) -I$(PATSHOMEQ)/ccomp/runtime -o $@ $<
fibver_loop_dats.c: fibver_loop.dats ;   $(PATSOPT) -IATS$(PATSHOMEQ)/contrib --output fibver_loop_dats.c --dynamic fibver_loop.dats
clean:: ; $(RMF) fibver_loop_dats.o
clean:: ; $(RMF) fibver_loop_dats.c
cleanall:: ; $(RMF) fibver_loop fibver_loop.exe

all:: fibver_trec
fibver_trec: fibver_trec.exe
fibver_trec.exe: fibver_trec_dats.c ;   $(CCOPT) -D_GNU_SOURCE -O2 -I$(PATSHOMEQ) -I$(PATSHOMEQ)/ccomp/runtime -o $@ $<
fibver_trec_dats.c: fibver_trec.dats ;   $(PATSOPT) -IATS$(PATSHOMEQ)/contrib --output fibver_trec_dats.c --dynamic fibver_trec.dats
clean:: ; $(RMF) fibver_trec_dats.o
clean:: ; $(RMF) fibver_trec_dats.c
cleanall:: ; $(RMF) fibver_trec fibver_trec.exe

all:: matrixops
matrixops: matrixops.exe
matrixops.exe: matrixops_dats.c ;   $(CCOPT) -D_GNU_SOURCE -O2 -I$(PATSHOMEQ) -I$(PATSHOMEQ)/ccomp/runtime -o $@ $<
matrixops_dats.c: matrixops.dats ;   $(PATSOPT) -IATS$(PATSHOMEQ)/contrib --output matrixops_dats.c --dynamic matrixops.dats
clean:: ; $(RMF) matrixops_dats.o
clean:: ; $(RMF) matrixops_dats.c
cleanall:: ; $(RMF) matrixops matrixops.exe

#
all:: autodiff
autodiff: autodiff.exe
autodiff.exe: autodiff_dats.c ;   $(CCOPT) -D_GNU_SOURCE -O2     -I$(PATSHOMEQ) -I$(PATSHOMEQ)/ccomp/runtime -DATS_MEMALLOC_GCBDW -O2 -o $@ $< -lm -lgc
autodiff_dats.c: autodiff.dats ;   $(PATSOPT) -IATS$(PATSHOMEQ)/contrib --output autodiff_dats.c --dynamic autodiff.dats
clean:: ; $(RMF) autodiff_dats.o
clean:: ; $(RMF) autodiff_dats.c
cleanall:: ; $(RMF) autodiff autodiff.exe

all:: fib_memo
fib_memo: fib_memo.exe
fib_memo.exe: fib_memo_dats.c ;   $(CCOPT) -D_GNU_SOURCE -O2     -I$(PATSHOMEQ) -I$(PATSHOMEQ)/ccomp/runtime -DATS_MEMALLOC_LIBC -o $@ $< -L$(PATSLIB) -latslib
fib_memo_dats.c: fib_memo.dats ;   $(PATSOPT) -IATS$(PATSHOMEQ)/contrib --output fib_memo_dats.c --dynamic fib_memo.dats
clean:: ; $(RMF) fib_memo_dats.o
clean:: ; $(RMF) fib_memo_dats.c
cleanall:: ; $(RMF) fib_memo fib_memo.exe

all:: fourslot
fourslot: fourslot.exe
fourslot.exe: fourslot_dats.c ;   $(CCOPT) -D_GNU_SOURCE -O2     -I$(PATSHOMEQ) -I$(PATSHOMEQ)/ccomp/runtime -DATS_MEMALLOC_LIBC -o $@ $< 
fourslot_dats.c: fourslot.dats ;   $(PATSOPT) -IATS$(PATSHOMEQ)/contrib --output fourslot_dats.c --dynamic fourslot.dats
clean:: ; $(RMF) fourslot_dats.o
clean:: ; $(RMF) fourslot_dats.c
cleanall:: ; $(RMF) fourslot fourslot.exe

all:: hanoi
hanoi: hanoi.exe
hanoi.exe: hanoi_dats.c ;   $(CCOPT) -D_GNU_SOURCE -O2     -I$(PATSHOMEQ) -I$(PATSHOMEQ)/ccomp/runtime -DATS_MEMALLOC_LIBC -o $@ $< 
hanoi_dats.c: hanoi.dats ;   $(PATSOPT) -IATS$(PATSHOMEQ)/contrib --output hanoi_dats.c --dynamic hanoi.dats
clean:: ; $(RMF) hanoi_dats.o
clean:: ; $(RMF) hanoi_dats.c
cleanall:: ; $(RMF) hanoi hanoi.exe

all:: intsqrt_cps
intsqrt_cps: intsqrt_cps.exe
intsqrt_cps.exe: intsqrt_cps_dats.c ;   $(CCOPT) -D_GNU_SOURCE -O2     -I$(PATSHOMEQ) -I$(PATSHOMEQ)/ccomp/runtime -DATS_MEMALLOC_LIBC -o $@ $< 
intsqrt_cps_dats.c: intsqrt_cps.dats ;   $(PATSOPT) -IATS$(PATSHOMEQ)/contrib --output intsqrt_cps_dats.c --dynamic intsqrt_cps.dats
clean:: ; $(RMF) intsqrt_cps_dats.o
clean:: ; $(RMF) intsqrt_cps_dats.c
cleanall:: ; $(RMF) intsqrt_cps intsqrt_cps.exe

all:: intsqrt_prf
intsqrt_prf: intsqrt_prf.exe
intsqrt_prf.exe: intsqrt_prf_dats.c ;   $(CCOPT) -D_GNU_SOURCE -O2     -I$(PATSHOMEQ) -I$(PATSHOMEQ)/ccomp/runtime -DATS_MEMALLOC_LIBC -o $@ $< 
intsqrt_prf_dats.c: intsqrt_prf.dats ;   $(PATSOPT) -IATS$(PATSHOMEQ)/contrib --output intsqrt_prf_dats.c --dynamic intsqrt_prf.dats
clean:: ; $(RMF) intsqrt_prf_dats.o
clean:: ; $(RMF) intsqrt_prf_dats.c
cleanall:: ; $(RMF) intsqrt_prf intsqrt_prf.exe

all:: monad_list
monad_list: monad_list.exe
monad_list.exe: monad_list_dats.c ;   $(CCOPT) -D_GNU_SOURCE -O2     -I$(PATSHOMEQ) -I$(PATSHOMEQ)/ccomp/runtime -DATS_MEMALLOC_LIBC -o $@ $< 
monad_list_dats.c: monad_list.dats ;   $(PATSOPT) -IATS$(PATSHOMEQ)/contrib --output monad_list_dats.c --dynamic monad_list.dats
clean:: ; $(RMF) monad_list_dats.o
clean:: ; $(RMF) monad_list_dats.c
cleanall:: ; $(RMF) monad_list monad_list.exe

all:: monad_maybe
monad_maybe: monad_maybe.exe
monad_maybe.exe: monad_maybe_dats.c ;   $(CCOPT) -D_GNU_SOURCE -O2     -I$(PATSHOMEQ) -I$(PATSHOMEQ)/ccomp/runtime -DATS_MEMALLOC_LIBC -o $@ $< 
monad_maybe_dats.c: monad_maybe.dats ;   $(PATSOPT) -IATS$(PATSHOMEQ)/contrib --output monad_maybe_dats.c --dynamic monad_maybe.dats
clean:: ; $(RMF) monad_maybe_dats.o
clean:: ; $(RMF) monad_maybe_dats.c
cleanall:: ; $(RMF) monad_maybe monad_maybe.exe

all:: monad_state
monad_state: monad_state.exe
monad_state.exe: monad_state_dats.c ;   $(CCOPT) -D_GNU_SOURCE -O2     -I$(PATSHOMEQ) -I$(PATSHOMEQ)/ccomp/runtime -DATS_MEMALLOC_LIBC -o $@ $< 
monad_state_dats.c: monad_state.dats ;   $(PATSOPT) -IATS$(PATSHOMEQ)/contrib --output monad_state_dats.c --dynamic monad_state.dats
clean:: ; $(RMF) monad_state_dats.o
clean:: ; $(RMF) monad_state_dats.c
cleanall:: ; $(RMF) monad_state monad_state.exe

all:: morse_enum
morse_enum: morse_enum.exe
morse_enum.exe: morse_enum_dats.c ;   $(CCOPT) -D_GNU_SOURCE -O2     -I$(PATSHOMEQ) -I$(PATSHOMEQ)/ccomp/runtime -DATS_MEMALLOC_LIBC -o $@ $< -L$(PATSLIB) -latslib
morse_enum_dats.c: morse_enum.dats ;   $(PATSOPT) -IATS$(PATSHOMEQ)/contrib --output morse_enum_dats.c --dynamic morse_enum.dats
clean:: ; $(RMF) morse_enum_dats.o
clean:: ; $(RMF) morse_enum_dats.c
cleanall:: ; $(RMF) morse_enum morse_enum.exe

all:: memoization
memoization: memoization.exe
memoization.exe: memoization_dats.c ;   $(CCOPT) -D_GNU_SOURCE -O2     -I$(PATSHOMEQ) -I$(PATSHOMEQ)/ccomp/runtime -DATS_MEMALLOC_LIBC -o $@ $< 
memoization_dats.c: memoization.dats ;   $(PATSOPT) -IATS$(PATSHOMEQ)/contrib --output memoization_dats.c --dynamic memoization.dats
clean:: ; $(RMF) memoization_dats.o
clean:: ; $(RMF) memoization_dats.c
cleanall:: ; $(RMF) memoization memoization.exe

all:: myfixptcomb
myfixptcomb: myfixptcomb.exe
myfixptcomb.exe: myfixptcomb_dats.c ;   $(CCOPT) -D_GNU_SOURCE -O2     -I$(PATSHOMEQ) -I$(PATSHOMEQ)/ccomp/runtime -DATS_MEMALLOC_LIBC -o $@ $< 
myfixptcomb_dats.c: myfixptcomb.dats ;   $(PATSOPT) -IATS$(PATSHOMEQ)/contrib --output myfixptcomb_dats.c --dynamic myfixptcomb.dats
clean:: ; $(RMF) myfixptcomb_dats.o
clean:: ; $(RMF) myfixptcomb_dats.c
cleanall:: ; $(RMF) myfixptcomb myfixptcomb.exe

all:: mysendmailist
mysendmailist: mysendmailist.exe
mysendmailist.exe: mysendmailist_dats.c ;   $(CCOPT) -D_GNU_SOURCE -O2     -I$(PATSHOMEQ) -I$(PATSHOMEQ)/ccomp/runtime -DATS_MEMALLOC_LIBC -o $@ $< 
mysendmailist_dats.c: mysendmailist.dats ;   $(PATSOPT) -IATS$(PATSHOMEQ)/contrib --output mysendmailist_dats.c --dynamic mysendmailist.dats
clean:: ; $(RMF) mysendmailist_dats.o
clean:: ; $(RMF) mysendmailist_dats.c
cleanall:: ; $(RMF) mysendmailist mysendmailist.exe

all:: passwdgen
passwdgen: passwdgen.exe
passwdgen.exe: passwdgen_dats.c ;   $(CCOPT) -D_GNU_SOURCE -O2     -I$(PATSHOMEQ) -I$(PATSHOMEQ)/ccomp/runtime -DATS_MEMALLOC_LIBC -o $@ $< 
passwdgen_dats.c: passwdgen.dats ;   $(PATSOPT) -IATS$(PATSHOMEQ)/contrib --output passwdgen_dats.c --dynamic passwdgen.dats
clean:: ; $(RMF) passwdgen_dats.o
clean:: ; $(RMF) passwdgen_dats.c
cleanall:: ; $(RMF) passwdgen passwdgen.exe

all:: queens_lazy
queens_lazy: queens_lazy.exe
queens_lazy.exe: queens_lazy_dats.c ;   $(CCOPT) -D_GNU_SOURCE -O2     -I$(PATSHOMEQ) -I$(PATSHOMEQ)/ccomp/runtime -DATS_MEMALLOC_LIBC -o $@ $< 
queens_lazy_dats.c: queens_lazy.dats ;   $(PATSOPT) -IATS$(PATSHOMEQ)/contrib --output queens_lazy_dats.c --dynamic queens_lazy.dats
clean:: ; $(RMF) queens_lazy_dats.o
clean:: ; $(RMF) queens_lazy_dats.c
cleanall:: ; $(RMF) queens_lazy queens_lazy.exe

all:: queens_loop
queens_loop: queens_loop.exe
queens_loop.exe: queens_loop_dats.c ;   $(CCOPT) -D_GNU_SOURCE -O2     -I$(PATSHOMEQ) -I$(PATSHOMEQ)/ccomp/runtime -DATS_MEMALLOC_LIBC -o $@ $< 
queens_loop_dats.c: queens_loop.dats ;   $(PATSOPT) -IATS$(PATSHOMEQ)/contrib --output queens_loop_dats.c --dynamic queens_loop.dats
clean:: ; $(RMF) queens_loop_dats.o
clean:: ; $(RMF) queens_loop_dats.c
cleanall:: ; $(RMF) queens_loop queens_loop.exe

all:: queens_comb
queens_comb: queens_comb.exe
queens_comb.exe: queens_comb_dats.c ;   $(CCOPT) -D_GNU_SOURCE -O2     -I$(PATSHOMEQ) -I$(PATSHOMEQ)/ccomp/runtime -DATS_MEMALLOC_LIBC -o $@ $< 
queens_comb_dats.c: queens_comb.dats ;   $(PATSOPT) -IATS$(PATSHOMEQ)/contrib --output queens_comb_dats.c --dynamic queens_comb.dats
clean:: ; $(RMF) queens_comb_dats.o
clean:: ; $(RMF) queens_comb_dats.c
cleanall:: ; $(RMF) queens_comb queens_comb.exe

all:: queens_lincomb
queens_lincomb: queens_lincomb.exe
queens_lincomb.exe: queens_lincomb_dats.c ;   $(CCOPT) -D_GNU_SOURCE -O2     -I$(PATSHOMEQ) -I$(PATSHOMEQ)/ccomp/runtime -DATS_MEMALLOC_LIBC -o $@ $< 
queens_lincomb_dats.c: queens_lincomb.dats ;   $(PATSOPT) -IATS$(PATSHOMEQ)/contrib --output queens_lincomb_dats.c --dynamic queens_lincomb.dats
clean:: ; $(RMF) queens_lincomb_dats.o
clean:: ; $(RMF) queens_lincomb_dats.c
cleanall:: ; $(RMF) queens_lincomb queens_lincomb.exe

all:: randerlin
randerlin: randerlin.exe
randerlin.exe: randerlin_dats.c ;   $(CCOPT) -D_GNU_SOURCE -O2     -I$(PATSHOMEQ) -I$(PATSHOMEQ)/ccomp/runtime -DATS_MEMALLOC_LIBC -o $@ $< 
randerlin_dats.c: randerlin.dats ;   $(PATSOPT) -IATS$(PATSHOMEQ)/contrib --output randerlin_dats.c --dynamic randerlin.dats
clean:: ; $(RMF) randerlin_dats.o
clean:: ; $(RMF) randerlin_dats.c
cleanall:: ; $(RMF) randerlin randerlin.exe

all:: readdirall
readdirall: readdirall.exe
readdirall.exe: readdirall_dats.c ;   $(CCOPT) -D_GNU_SOURCE -O2     -I$(PATSHOMEQ) -I$(PATSHOMEQ)/ccomp/runtime -DATS_MEMALLOC_LIBC -o $@ $< -L$(PATSLIB) -latslib
readdirall_dats.c: readdirall.dats ;   $(PATSOPT) -IATS$(PATSHOMEQ)/contrib --output readdirall_dats.c --dynamic readdirall.dats
clean:: ; $(RMF) readdirall_dats.o
clean:: ; $(RMF) readdirall_dats.c
cleanall:: ; $(RMF) readdirall readdirall.exe

all:: sieve
sieve: sieve.exe
sieve.exe: sieve_dats.c ;   $(CCOPT) -D_GNU_SOURCE -O2     -I$(PATSHOMEQ) -I$(PATSHOMEQ)/ccomp/runtime -DATS_MEMALLOC_LIBC -o $@ $< 
sieve_dats.c: sieve.dats ;   $(PATSOPT) -IATS$(PATSHOMEQ)/contrib --output sieve_dats.c --dynamic sieve.dats
clean:: ; $(RMF) sieve_dats.o
clean:: ; $(RMF) sieve_dats.c
cleanall:: ; $(RMF) sieve sieve.exe

=== debian/changelog ===
ats2-lang (0.3.11-2) unstable; urgency=medium

  * Add missing copyright info. (Closes: #905057)

 -- Matthew Danish <mrd@debian.org>  Tue, 31 Jul 2018 12:08:02 +0100

ats2-lang (0.3.11-1) unstable; urgency=medium

  * New upstream release. (Closes: #889786)

 -- Matthew Danish <mrd@debian.org>  Sun, 29 Jul 2018 07:36:21 -0400

ats2-lang (0.3.9-1) unstable; urgency=medium

  * New upstream release

 -- Matthew Danish <mrd@debian.org>  Wed, 07 Feb 2018 10:34:21 -0500

=== debian/control ===
Source: ats2-lang
Section: devel
Priority: optional
Maintainer: Matthew Danish <mrd@debian.org>
Build-Depends: debhelper (>= 10.0.0), libgmp-dev, dh-elpa (>= 0.0.17)
Standards-Version: 4.1.5.0
Homepage: http://www.ats-lang.org/
Vcs-Browser: https://salsa.debian.org/debian/ats2-lang
Vcs-Git: https://salsa.debian.org/debian/ats2-lang.git

Package: ats2-lang
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libgc-dev
Description: ATS version 2 programming language compiler
 ATS2 a.k.a. ATS/Postiats is a programming language with a highly expressive
 type system rooted in the framework Applied Type System. In particular, both
 dependent types and linear types are available in ATS. The current
 implementation of ATS (ATS/Postiats) is written in ATS (ATS/Anairiats) itself.
 It can be as efficient as C/C++ and supports a variety of programming
 paradigms.
 .
 In addition, ATS contains a component ATS/LF that supports a form of
 (interactive) theorem proving, where proofs are constructed as total
 functions. With this component, ATS advocates a programming style
 that combines programming with theorem proving. Furthermore, this
 component may be used as a logical framework to encode various
 deduction systems and their (meta-)properties.
 .
 This package contains the compiler patsopt and the frontend patscc.

Package: elpa-ats2-mode
Architecture: all
Section: lisp
Depends: ${misc:Depends}, ${elpa:Depends}
Built-Using: ${misc:Built-Using}
Recommends: emacs (>= 46.0)
Enhances: emacs, emacs24, emacs25
Description: ATS version 2 programming language emacs mode
 ATS2 a.k.a. ATS/Postiats is a programming language with a highly expressive
 type system rooted in the framework Applied Type System. In particular, both
 dependent types and linear types are available in ATS. The current
 implementation of ATS (ATS/Postiats) is written in ATS (ATS/Anairiats) itself.
 It can be as efficient as C/C++ and supports a variety of programming
 paradigms.
 .
 This package contains the emacs mode for ATS2.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
export DEB_BUILD_MAINT_OPTIONS=hardening=+all

%:
	dh $@  --no-parallel --with elpa

override_dh_auto_install:
	dh_auto_install --destdir debian/ats2-lang
	find debian/ats2-lang -name .keeper -exec rm \{\} \;
	# For now, until there is a flycheck package
	rm -f debian/ats2-lang/usr/share/emacs/site-lisp/ats2-mode/flycheck-ats2.el
	find debian/ats2-lang -wholename '*TEST/Worker*' -delete
	find debian/ats2-lang -wholename '*TEST/Counter*' -delete
	find debian/ats2-lang -name 'theDeclpostamble.html' -delete
	find debian/ats2-lang -name 'rpc_client.html' -delete
	find debian/ats2-lang -name 'test_client.html' -delete
	find debian/ats2-lang -name 'test2_client.html' -delete
	find debian/ats2-lang -name 'test3_client.html' -delete
	find debian/ats2-lang -wholename '*/contrib/*/README*' -delete
	find debian/ats2-lang -wholename '*/contrib/*/LICENSE*' -delete
	find debian/ats2-lang -type d -empty -delete
	mkdir -p debian/ats2-lang/usr/share/doc/ats2-lang
	cp CHANGES-ats2 debian/ats2-lang/usr/share/doc/ats2-lang/changelog
	gzip -9 debian/ats2-lang/usr/share/doc/ats2-lang/changelog

override_dh_clean:
	dh_clean
	rm -f src/CBOOT/libatsopt.a
